{$S-,D-,V-,R-
                FILES  Unit

           Release  : 24.01.95

}

Unit Files;

Interface

Uses Lib, Dos;

const
        ROnly   = $00;            Exclusive = $10;
        WOnly   = $01;            DenyWrite = $20;
        RdWr    = $02;            DenyRead  = $30;
        Inherit = $80;            Shared    = $40;

const
        CheckError: Boolean = True;
        DosBreak: Boolean = True;


type
    Diagnostics = record
       Code,             { ७  訡 }
       Class,            {  訡           }
       Action,           { 㥬 ⢨ }
       Locus: Word;      { 筨 訡        }
    end;



function  FOpen( Path: PathStr; Mode: Byte): Word;
function  FCreate( Path: PathStr; Attr: Byte): Word;
function  FRead( Handle, Count: Word; var Buf): Word;
function  FWrite( Handle, Count: Word; var Buf): Word;
function  FSeek( Handle: Word; Pos: LongInt; Mode: Byte): LongInt;
procedure FClose( Handle: Word);
procedure FErase( Path: PathStr);
procedure FRename( OldName, NewName: PathStr);
procedure FFlush( Handle: Word);
procedure FLock( Handle: Word; O, L: LongInt; Mode: Byte);
function  FCreateUnique( var Path: PathStr; Attr: Byte): Word;
function  FAttr( Attr: Word; Path: PathStr; Mode: Byte): Word;
procedure GetErrInfo( var D: Diagnostics);
function  GetErrCode: Word;
procedure Execute( const Path, CommandLine: PathStr);
function  Exists( Path: PathStr): Boolean;
function  CurrentDate: DateStr;
procedure EnableDrive( Drive: Byte);
procedure DisableDrive( Drive: Byte);


type
    BinFile = object
       Handle_  : Word;
       Name_    : PathStr;    {   䠩           }

       procedure Assign( const FName: PathStr);
       procedure Open( Mode: Word);
       procedure Create( Attr: Word);
       procedure Truncate;
       procedure Close;
       procedure Seek( Position: LongInt);
       function  FilePos: LongInt;
       function  SeekEof: LongInt;
       function  BlockRead( Size: Word; var Buf): Word;
       function  BlockWrite(Size: Word; var Buf): Word;
       procedure Erase;
       procedure Rename( const NewName: PathStr);
       procedure Lock( Offset, Length: LongInt);
       procedure UnLock( Offset, Length: LongInt);
       procedure CreateUnique( Attr: Word);
       procedure Flush;
       procedure SetAttr( Attr: Word);
       function  GetAttr: Word;
    end;



const
    OpenMode:   Word = RdWr + Exclusive;
    CreateAttr: Byte = 0;



type BytePointer = record
                      case Byte of
                         0 : (Ptr: ^Byte);
                         1 : (Pos: Word; Seg: Word);
                      end;


type
    SmartFile = object( BinFile)
       BufSize_ : Word;        {                                 }
       FilSize_ : LongInt;     {  䠩  ⮬       }
       DskPos1_ : LongInt;     {   ᪥,  ண 㧨     }
       DskPos2_ : LongInt;
       BufOfs1_ : Word;        { 饭  砫 ࠣ                }
       BufOfs2_ : Word;        { 饭  砫 ࠣ                }
       Buf1_    : BytePointer; {   ,  ண 稭  }
       BufSeg2_ : Word;        {   2-                 }
       BufEnd1_ : Word;        {  ࠭ 㦥            }
       BufEnd2_ : Word;        {  ࠭ 㦥            }
       WrFlag1_ : Boolean;     {  ࠧ稩   ᪥       }
       WrFlag2_ : Boolean;     {  ࠧ稩   ᪥       }

       procedure Open( InitBufSize: Word);
       procedure Create( InitBufSize: Word);
       procedure CreateUnique( InitBufSize: Word);
       procedure SwapBuffers;
       procedure ChangeBuffer;
       procedure UpdateBuffers( Pos: LongInt; Count: Word; var Buf);
       procedure Seek( Position: LongInt);
       procedure BlockRead;
       procedure BlockWrite;
       procedure Flush;
       procedure Truncate;
       procedure Close;
       function  FilePos: LongInt;
       function  Eof: Boolean;
       procedure SeekEof;
       procedure Put( B: Byte);
       procedure WrByte( B: Byte);
       procedure WrWord( W: Word);
       procedure WrLong( L: LongInt);
       procedure WrChar( Ch: Char; Count: Word);
       procedure WrCharRep( Ch: Char; Count: Word);
       procedure WrStr( St: String; Count: Word);
       procedure WrString( St: String);
       procedure WrLn;
       procedure WrStrLn( St: String; Count: Word);
       procedure WrBuf( Count: Word; var Buf);
       function  Get: Byte;
       function  SeekAndGet( Pos: LongInt): Byte;
       function  RdByte: Byte;
       function  RdWord: Word;
       function  RdLong: LongInt;
       function  RdStr( Count: Byte): String;
       function  RdString: String;
       function  ReadEqual( var Model: String): Boolean;
       procedure RdBuf( Count: Word; var Buf);
       procedure Error( Mess: String);
   end;

{

     䠩 ⨯ .DBF

    DBF-䠩 ⮨    ᥩ  묨.
 稭  㫥 樨,   묨
᫥  .


 ͻ
                   䠩 ⨯ .DBF                 
 Ķ
                  ᠭ                            
 Ķ
  00      䠩  묨:                            
          FoxBASE+/dBASE III +,  memo - 003            
          FoxBASE+/dBASE III +,  memo - 083              
          FoxPro/dBASE IV,  memo - 003                 
          FoxPro  memo - 0F5                             
          dBASE IV  memo - 0x8B                           
 Ķ
  01-03  ᫥  ()                      
 Ķ
  04-07  ᫮ ᥩ  䠩                             
 Ķ
  08-09   ࢮ   묨                 
 Ķ
  10-11      묨                      
          ( ਧ 㤠)                       
 Ķ
  12-27  १ࢨ஢                                   
 Ķ
  28     1- .⠢ .䠩 (⨯ .CDX),0-
 Ķ
  29-31  १ࢨ஢                                   
 Ķ
  32-n                                    
 Ķ
   n+1   ਧ 襭   (001)        
 ͼ


      DBF-䠩 稭  樨, 㪠뢠 
   08-09.   묨 稭  ,
ᮤঠ饣 ਧ 㤠 :
  - ஡    (020) -   㤠﫠;
  - 窠 (02A) -  㤠.
 ਧ 㤠 ᫥   ,  
室   .


 ͻ
                                            
 Ķ
                    ᠭ                          
 Ķ
  00-10    (ᨬ쭮 - 10 ᨬ, ᫨    
          10,    ᨬ (000)) 
 Ķ
  11      :                                       
          C - ᨬ쭮;                                  
          N - ᫮;                                    
          L - ᪮;                                  
          M - ⨯ memo;                                   
          D - ;                                        
          F -  饩 窮;                          
          P - 蠡.                                      
 Ķ
  12-15  ᯮ                      
 Ķ
  16       ( )                             
 Ķ
  17     ᫮  ࠧ冷                         
 Ķ
  18-32  १ࢨ஢                                   
 ͼ


}

const
     DBFOpenCheck: Boolean = True;

type

{
    DBF-䠩 ࠭  RAM  
  吝 ᯨ᪠ 㧫  ன DataField
}
   FieldName = String[10];              {                  }
   DataPoint = ^DataField;              { ⥫  ᫥. 㧥      }

   DataField = record
                  Next: DataPoint;      { ⥫  ᫥. 㧥      }
                  Name: FieldName;      {                  }
                  Typ: Char;            {                     }
                  Offset: Word;         { 饭  砫     }
                  Size: Byte;           {              }
                  DecPlaces: Byte;      { ᫮ ࠧ冷 ᫥ ⮩ }
               end;

type DBaseFile = object( SmartFile)

   RecCount_,              { ᫮ ᥩ     }
   RecNo_: LongInt;        {  ⨢         }
   HeaderSize_,            {      }
   RecSize_: Word;         {              }
   Field_: DataPoint;      { ⥫ ᯨ᪠        }
   Buf_1,                  {   ࠭    }
   Buf_2: Pointer;         {                      }

   procedure Open( FileName: String; Size: Word);
   procedure Close;
   procedure ReOpen;
   procedure Flush;

                            { ᪮ 㤠 ᥩ }
   procedure Truncate;
   procedure Remove;
   procedure Zap;
   procedure Pack;
                         { ⠭  ⨢  }
   procedure GoTop;
   procedure GoBottom;
   procedure Go( N: LongInt);
   procedure Skip( N: LongInt);

   function  RecNo: LongInt;
   function  RecCount: LongInt;
   function  RecSize: Word;
   function  Eod: Boolean;
   procedure AppendBlank;
   procedure FastAppend(var Buffer);
   procedure FastFixRecCount;
   procedure FixRecCount;
   procedure AppendFrom(var Buffer);
   procedure FastScatter(var Buffer);
   procedure FastGather(var Buffer);
   procedure FastSwap;
   procedure ScatterBlank(var Buffer);
   procedure Append;

                                {  ᫠ 祭 ᥩ }
   function  DelCount: LongInt;

                                { 樨  ⪠ ᥩ }
   procedure FastDelete;
   procedure Delete;
   procedure FastToggle;
   procedure Toggle;
   procedure ToggleIn( var Buffer);
   procedure FastRecall;
   procedure Recall;
   procedure RecallAll;
   function  FastDeleted: Boolean;

   function  FindField( Ident: FieldName): DataPoint;
   function  FieldExists( Ident: FieldName): Boolean;
   function  Len( Ident: FieldName): Byte;
   function  FieldOfs( Ident: FieldName): Word;
   function  MaxLen: Byte;
   function  FieldCount: Word;
   procedure FastReplace( Ident: FieldName; Source: String);
   procedure Replace( Ident: FieldName; Source: String);
   procedure WrStr( Offset: Word; Source: String);
   function  FastStore( Ident: FieldName): String;
   function  Store( Ident: FieldName): String;
   function  RdStr( Offset: Word; Count: Byte): String;
   procedure Restore( Ident: FieldName);
   function  ReadEqual( var Model: String; Offs: Word): Boolean;
   procedure ReplaceIn( Ident: FieldName; Source: String; var Buffer);
   function  StoreFrom( Ident: FieldName; var Buffer): String;
   function  RecordUpdated: Boolean;
   function  BufferUpdated( var Buffer): Boolean;
   function  FieldUpdated( Ident: FieldName): Boolean;
   procedure BackUp;
   procedure BackUpBuffer( var Buffer);
   procedure Undo;
   procedure UndoBuffer( var Buffer);
   procedure FastLocate( FldName: FieldName; FldVal: String);
   procedure FastLocateBack( FldName: FieldName; FldVal: String);
   procedure FastLocateFirst( FldName: FieldName; FldVal: String);
   procedure Init;
   procedure AppendField( Ident: FieldName; FTyp: Char; FSize, FDec: Byte);
   procedure DeleteField( Ident: FieldName);
   procedure FastSetDate;
   procedure Create( FileName: String; Size: Word);
   procedure BubbleSort( Ident: FieldName);
   procedure Gather;
   procedure GatherFrom( var Buffer);
   procedure Scatter;

end;

function  FError: Boolean;

Implementation



             { ***  LOW-LEVEL  FILE  OPERATIONS  *** }


function FOpen( Path: PathStr; Mode: Byte): Word; assembler;
   asm
            mov     DosError,0      { clear error flag }
            mov     al,Mode
            push    ds
            lds     dx,Path
            mov     ah,3dh          { open file }
            int     21h
            pop     ds
            jnc     @@Done
            mov     DosError,ax     { set error code }
@@Done:
   end;


function FCreate( Path: PathStr; Attr: Byte): Word; assembler;
   asm
            mov     DosError,0      { clear error flag }
            xor     ch,ch
            mov     cl,Attr
            push    ds
            lds     dx,Path
            mov     ah,3ch          { create file }
            int     21h
            pop     ds
            jnc     @@Done
            mov     DosError,ax     { set error flag }
@@Done:
   end;


function FRead( Handle, Count: Word; var Buf): Word; assembler;
   asm
            mov     DosError,0      { clear error flag }
            xor     ax,ax
            mov     cx,Count
            jcxz    @@Done
            mov     bx,Handle
            push    ds
            lds     dx,Buf
            mov     ah,3fh          { read from file }
            int     21h
            pop     ds
            jnc     @@Done
            mov     DosError,ax     { set error flag }
@@Done:
   end;


function FWrite( Handle, Count: Word; var Buf): Word; assembler;
   asm
            mov     DosError,0      { clear error flag }
            mov     cx,Count
            mov     bx,Handle
            push    ds
            lds     dx,Buf
            mov     ah,40h          { write to file }
            int     21h
            pop     ds
            jnc     @@Done
            mov     DosError,ax     { set error flag }
@@Done:
   end;


function  FSeek( Handle: Word; Pos: LongInt; Mode: Byte): LongInt; assembler;
   asm
            mov     DosError,0      { clear error flag }
            les     dx,Pos
            mov     cx,es
            mov     bx,Handle
            mov     al,Mode
            mov     ah,42h          { seek function }
            int     21h
            jnc     @@Done
            mov     DosError,ax     { set error flag }
@@Done:
   end;


procedure FClose( Handle: Word); assembler;
   asm
            mov     DosError,0      { clear error flag }
            mov     bx,Handle
            mov     ah,3eh          { close file }
            int     21h
            jnc     @@Done
            mov     DosError,ax     { set error flag }
@@Done:
   end;


procedure FErase( Path: PathStr); assembler;
   asm
            mov     DosError,0      { clear error flag }
            push    ds
            lds     dx,Path
            mov     ah,41h          { erase file }
            int     21h
            pop     ds
            jnc     @@Done
            mov     DosError,ax     { set error flag }
@@Done:
   end;


procedure FRename( OldName, NewName: PathStr); assembler;
   asm
            mov     DosError,0      { clear error flag }
            push    ds
            les     di,NewName
            lds     dx,OldName
            mov     ah,56h          { rename file }
            int     21h
            pop     ds
            jnc     @@Done
            mov     DosError,ax     { set error flag }
@@Done:
   end;


procedure FFlush( Handle: Word); assembler;
   asm
            mov     DosError,0      { clear error flag }
            mov     bx,Handle
            mov     ah,68h          { flush file }
            int     21h
            jnc     @@Done
            mov     DosError,ax     { set error flag }
@@Done:
   end;


procedure FLock( Handle: Word; O, L: LongInt; Mode: Byte); assembler;
   asm
            mov     al,Mode         { 0=Lock, 1=UnLock }
            mov     DosError,0      { clear error flag }
            mov     cx,O.Word[2]
            mov     dx,O.Word[0]
            mov     si,L.Word[2]
            mov     di,L.Word[0]
            mov     bx,Handle
            mov     ah,5ch
            int     21h
            jnc     @@Done
            mov     DosError,ax     { set error flag }
@@Done:
   end;


function FCreateUnique( var Path: PathStr; Attr: Byte): Word; assembler;
   asm
            mov     DosError,0      { clear error flag }
            xor     cx,cx
            mov     cl,Attr
            push    ds
            lds     dx,Path
            mov     ah,5ah          { create file with unique name }
            int     21h
            mov     bx,ds
            pop     ds
            jnc     @@Skip
            mov     DosError,ax     { set error flag }
            jmp     @@Done
@@Skip:
            mov     Path.Word[0],dx
            mov     Path.Word[2],bx
@@Done:
   end;


function  FAttr( Attr: Word; Path: PathStr; Mode: Byte): Word; assembler;
   asm
            mov     DosError,0      { clear error flag }
            push    ds
            mov     cx,Attr
            lds     dx,Path
            mov     al,Mode         { 0=get, 1=set }
            mov     ah,43h          { get or set file attribute }
            int     21h
            pop     ds
            jnc     @@Done
            mov     DosError,ax     { set error flag }
@@Done:
   end;


procedure GetErrInfo( var D: Diagnostics); assembler;
   asm
            push    ds
            mov     ax,5900h
            xor     bx,bx
            int     21h
            pop     ds
            mov     bp,sp
            les     di,D
            cld
            stosw                   { extended error code }
            xor     ax,ax
            mov     al,bh
            stosw                   { error class }
            mov     al,bl
            stosw                   { suggested action }
            mov     al,ch
            stosw                   { locus (source of error) }
   end;


function GetErrCode: Word;
   var D: Diagnostics;

   begin
      GetErrInfo( D);
      GetErrCode:= D.Code;
   end;


function  ErrorChecked( const FileName, Message: String): Boolean;
   var L: Byte;
       NameLen: Byte absolute FileName;
       MessLen: Byte absolute Message;

   begin
      ErrorChecked:= True;
      if (DosError=0) or not CheckError then Exit;
      if DosBreak then begin
         Halt;
      end;
   end;


procedure Execute;
   begin
      repeat
         Exec( Path, CommandLine);
      until ErrorChecked( Path, '   ணࠬ');
   end;


function Exists;
   var R: SearchRec;

   begin
      FindFirst( Path, AnyFile-VolumeID-Directory, R);
      Exists:= (DosError=0);
      DosError:= 0;
   end;


function CurrentDate;
   var Year, Month, Day, DayOfWeek: Word;
       S, St: String;

   begin
      GetDate( Year, Month, Day, DayOfWeek);
      Str( Year:4, S);
      Str( Month:2, St);
      if St[1]=' ' then St[1]:= '0';
      S:= S+St;
      Str( Day:2, St);
      if St[1]=' ' then St[1]:= '0';
      S:= S+St;
      S[0]:= #8;
      CurrentDate:= S;
   end;


procedure EnableDrive( Drive: Byte); assembler;
   asm
            mov     ax,5F07h
            mov     DosError,0      { clear error flag }
            mov     dl,Drive        { drive number ( 0=A:) }
            int     21h
            jnc     @@Done
            mov     DosError,ax     { save error code }
@@Done:
   end;


procedure DisableDrive( Drive: Byte); assembler;
   asm
            mov     ax,5F08h
            mov     DosError,0      { clear error flag }
            mov     dl,Drive        { drive number ( 0=A:) }
            int     21h
            jnc     @@Done
            mov     DosError,ax     { save error code }
@@Done:
   end;


procedure DiskOverflow( Name: PathStr);
   var
      NameLen: Byte absolute Name;
      L: Byte;

   begin
   end;


function FError;
   begin
      FError:= DosError<>0;
      DosError:= 0;
   end;



                 { ***  BINFILE  IMPLEMENTATION  *** }


procedure BinFile.Assign;
   begin
      Name_:= Upper( FName);
   end;


procedure BinFile.Open;
   begin
      if DosError<>0 then Exit;
      repeat
         Handle_:= FOpen( Str2Asc( Name_), Mode);
      until ErrorChecked( Name_, 'Open error');
   end;


procedure BinFile.Create;
   begin
      if DosError<>0 then Exit;
      repeat
         Handle_:= FCreate( Str2Asc( Name_), Attr);
      until ErrorChecked( Name_, 'Create error');
   end;


function BinFile.BlockRead;
   begin
      if DosError<>0 then Exit;
      if Size>0 then repeat
         BlockRead:= FRead( Handle_, Size, Buf);
      until ErrorChecked( Name_, 'Read error');
   end;


function BinFile.BlockWrite;
   begin
      if DosError<>0 then Exit;
      if Size>0 then repeat
         BlockWrite:= FWrite( Handle_, Size, Buf);
      until ErrorChecked( Name_, 'Write error');
   end;


procedure BinFile.Truncate;
   begin
      if DosError<>0 then Exit;
      repeat
         FWrite( Handle_, 0, Ptr( 0, 0)^);
      until ErrorChecked( Name_, 'Truncate error');
   end;


procedure BinFile.Close;
   begin
      if DosError<>0 then Exit;
      repeat
         FClose( Handle_);
      until ErrorChecked( Name_, 'Close error');
   end;


procedure BinFile.Seek;
   begin
      if DosError<>0 then Exit;
      repeat
         FSeek( Handle_, Position, 0);
      until ErrorChecked( Name_, 'Seek error');
   end;


function BinFile.FilePos;
   begin
      if DosError<>0 then Exit;
      repeat
         FilePos:= FSeek( Handle_, 0, 1);
      until ErrorChecked( Name_, 'FilePos error');
   end;


function BinFile.SeekEof;
   begin
      if DosError<>0 then Exit;
      repeat
         SeekEof:= FSeek( Handle_, 0, 2);
      until ErrorChecked( Name_, 'Seek EOF error');
   end;


procedure BinFile.Erase;
   begin
      if DosError<>0 then Exit;
      repeat
         FErase( Str2Asc( Name_));
      until ErrorChecked( Name_, 'Erase error');
   end;


procedure BinFile.Rename;
   begin
      if DosError<>0 then Exit;
      repeat
         FRename( Str2Asc( Name_), Str2Asc( NewName));
      until ErrorChecked( Name_, 'Rename error');
      if DosError=0 then Name_:= NewName;
   end;


procedure BinFile.Lock;
   begin
      if DosError<>0 then Exit;
      repeat
         FLock( Handle_, Offset, Length, 0);
      until ErrorChecked( Name_, 'Lock error');
   end;


procedure BinFile.UnLock;
   begin
      if DosError<>0 then Exit;
      repeat
         FLock( Handle_, Offset, Length, 1);
      until ErrorChecked( Name_, 'Unlock error');
   end;


procedure BinFile.CreateUnique;
   var S: PathStr;

   begin
      if DosError<>0 then Exit;
      repeat
         S:= Str2Asc( Name_);
         Handle_:= FCreateUnique( S, Attr);
      until ErrorChecked( Name_, 'Create Unique error');
      if DosError=0 then Name_:= Asc2Str( S);
   end;


procedure BinFile.Flush;
   begin
      if DosError<>0 then Exit;
      repeat
         FFlush( Handle_);
      until ErrorChecked( Name_, 'Flush error');
   end;


procedure BinFile.SetAttr;
   begin
      if DosError<>0 then Exit;
      repeat
         FAttr( Attr, Str2Asc( Name_), 1);
      until ErrorChecked( Name_, 'SetAttr error');
   end;


function  BinFile.GetAttr;
   begin
      if DosError<>0 then Exit;
      repeat
         GetAttr:= FAttr( 0, Str2Asc( Name_), 0);
      until ErrorChecked( Name_, 'GetAttr error');
   end;


procedure SmartFile.Open;
   var P: Pointer;

   begin
      if InitBufSize<128 then InitBufSize:= 128;
      BufSize_:= InitBufSize;
      DskPos1_:= 0;
      DskPos2_:= 0;
      Buf1_.Pos:= 0;
      BufEnd1_:= 0;                 { 1-  ⮩ }
      BufEnd2_:= 0;                 { 2-  ⮩ }
      WrFlag1_:= False;
      WrFlag2_:= False;
      BinFile.Open( OpenMode);
      FilSize_:= BinFile.SeekEof;
      if DosError<>0 then Exit;
                                     {  , ᮧ 1-  }
      GetMem( P, InitBufSize+15);
      Buf1_.Seg:= Seg( P^);
      BufOfs1_:= Ofs( P^);
      if BufOfs1_<>0 then Inc( Buf1_.Seg);
                                     { 塞 1-  }
      if FilSize_>0 then begin
         BinFile.Seek( 0);
         BufEnd1_:= BinFile.BlockRead( BufSize_, Ptr( Buf1_.Seg, 0)^);
      end;
      if DosError<>0 then begin
         FreeMem( P, InitBufSize+15);
         Exit;
      end;
                             { 1-  , ᮧ 2-  }
      GetMem( P, InitBufSize+15);
      BufSeg2_:= Seg( P^);
      BufOfs2_:= Ofs( P^);
      if BufOfs2_<>0 then Inc( BufSeg2_);
   end;

procedure SmartFile.Create;
   var P: Pointer;

   begin
      if InitBufSize<128 then InitBufSize:= 128;
      BufSize_:= InitBufSize;
      DskPos1_:= 0;
      Buf1_.Pos:= 0;
      BufEnd1_:= 0;
      BufEnd2_:= 0;
      FilSize_:= 0;
      WrFlag1_:= False;
      WrFlag2_:= False;
      BinFile.Create( CreateAttr);
      if DosError<>0 then Exit;

      GetMem( P, InitBufSize+15);
      Buf1_.Seg:= Seg( P^);
      BufOfs1_:= Ofs( P^);
      if BufOfs1_<>0 then Inc( Buf1_.Seg);

      GetMem( P, InitBufSize+15);
      BufSeg2_:= Seg( P^);
      BufOfs2_:= Ofs( P^);
      if BufOfs2_<>0 then Inc( BufSeg2_);
   end;

procedure SmartFile.CreateUnique;
   var P: Pointer;

   begin
      if InitBufSize<128 then InitBufSize:= 128;
      BufSize_:= InitBufSize;
      DskPos1_:= 0;
      Buf1_.Pos:= 0;
      BufEnd1_:= 0;
      BufEnd2_:= 0;
      FilSize_:= 0;
      WrFlag1_:= False;
      WrFlag2_:= False;
      BinFile.CreateUnique( CreateAttr);
      if DosError<>0 then Exit;

      GetMem( P, InitBufSize+15);
      Buf1_.Seg:= Seg( P^);
      BufOfs1_:= Ofs( P^);
      if BufOfs1_<>0 then Inc( Buf1_.Seg);

      GetMem( P, InitBufSize+15);
      BufSeg2_:= Seg( P^);
      BufOfs2_:= Ofs( P^);
      if BufOfs2_<>0 then Inc( BufSeg2_);
   end;

procedure SmartFile.SwapBuffers;
   var
      SaveLong: LongInt;
      SaveWord: Word absolute SaveLong;
      SaveBool: Boolean absolute SaveLong;

   begin
      SaveLong:= DskPos1_;
      DskPos1_:= DskPos2_;
      DskPos2_:= SaveLong;
      SaveWord:= BufOfs1_;
      BufOfs1_:= BufOfs2_;
      BufOfs2_:= SaveWord;
      SaveWord:= Buf1_.Seg;
      Buf1_.Seg:= BufSeg2_;
      BufSeg2_:= SaveWord;
      SaveWord:= BufEnd1_;
      BufEnd1_:= BufEnd2_;
      BufEnd2_:= SaveWord;
      SaveBool:= WrFlag1_;
      WrFlag1_:= WrFlag2_;
      WrFlag2_:= SaveBool;
   end;

{ Warning !!! -  ஢ન  䠩 }
procedure SmartFile.UpdateBuffers;
   var DiskPos: LongInt;
       N,
       DiskOfs: Word;
       Swapped: Boolean;
       P: BytePointer;

   begin
      P.Ptr:= @Buf;
      DiskOfs:= Pos mod BufSize_;
      DiskPos:= Pos - DiskOfs;
      if FilSize_<Pos+Count then FilSize_:= Pos+Count;
      Swapped:= False;
      while Count>0 do begin
         if DskPos1_<>DiskPos then begin
            SwapBuffers;
            Swapped:= not Swapped;
         end;
         N:= BufSize_-DiskOfs;
         if N>Count then N:= Count;
         if DskPos1_=DiskPos then begin
            Move( P.Ptr^, Ptr( Buf1_.Seg, DiskOfs)^ , N);
            if BufEnd1_<DiskOfs+N then BufEnd1_:= DiskOfs+N;
         end;
         DiskPos:= DiskPos+BufSize_;
         DiskOfs:= 0;
         P.Pos:= P.Pos+N;
         Count:= Count-N;
      end;

{ 2-    ᯮ㥬 !!! }
      if Swapped then SwapBuffers;
   end;

procedure SmartFile.Seek;
{
 --------------------------------
 Resume: 樮஢ 䠩.
 Upgrade release 22.03.95.
 --------------------------------
}
   begin
{ ᫨    ⥪騩  }
      if (Position<DskPos1_) or (Position>=DskPos1_+BufEnd1_) then begin
         if (Position>FilSize_) or (Position<0) then
            Error( 'Fatal error - seek past eof');
         SwapBuffers;
         if (Position<DskPos1_) or (Position>=DskPos1_+BufEnd1_)
         then begin
            if WrFlag1_ then BlockWrite;
            DskPos1_:= Position - (Position mod BufSize_);
            BlockRead;
         end;
      end;
      Buf1_.Pos:= Position-DskPos1_;
   end;

procedure SmartFile.BlockRead;
   begin
      BinFile.Seek( DskPos1_);
      if DskPos1_=FilSize_ then BufEnd1_:= 0
      else BufEnd1_:= BinFile.BlockRead( BufSize_, Ptr( Buf1_.Seg, 0)^);
      WrFlag1_:= False;
      if DosError=0 then
         if FilSize_<= DskPos1_+BufEnd1_ then  { <=   < [ else-⢨] }
{ ᪠ 㢥祭  䠩 㣮 ணࠬ }
            FilSize_:= DskPos1_+BufEnd1_
         else if (DskPos1_=FilSize_-(FilSize_ mod BufSize_))
              or ( BufEnd1_<>BufSize_)
{  ᪠ 㬥襭  䠩 㣮 ணࠬ }
              then Error( 'Fatal Read Error');
   end;

procedure SmartFile.BlockWrite;
   var NN: Word;

   begin
      BinFile.Seek( DskPos1_);
      NN:= BinFile.BlockWrite( BufEnd1_, Ptr( Buf1_.Seg, 0)^);
      WrFlag1_:= False;
      if (DosError>0) or (NN=BufEnd1_) then Exit;
      DiskOverflow( Name_);
      if DosBreak then Halt;
   end;

procedure SmartFile.Flush;
   begin
      if WrFlag1_ then BlockWrite;
      SwapBuffers;
      if WrFlag1_ then BlockWrite;
      SwapBuffers;
   end;

procedure SmartFile.Truncate;
   begin
      Flush;
      BufEnd1_:= Buf1_.Pos;
      FilSize_:= DskPos1_+BufEnd1_;
      BinFile.Seek( FilSize_);
      BinFile.Truncate;
      BinFile.Flush;
   end;

procedure SmartFile.Close;
   var P: Pointer;

   begin
      if DosError<>0 then Exit;
      Flush;
      if BufOfs1_<>0 then Dec( Buf1_.Seg);
      P:= Ptr( Buf1_.Seg, BufOfs1_);
      FreeMem( P, BufSize_+15);
      if BufOfs2_<>0 then Dec( BufSeg2_);
      P:= Ptr( BufSeg2_, BufOfs2_);
      FreeMem( P, BufSize_+15);
      BinFile.Close;
   end;

function SmartFile.FilePos;
   begin
      FilePos:= DskPos1_+Buf1_.Pos;
   end;

function SmartFile.Eof;
   begin
      Eof:= FilSize_<=DskPos1_+Buf1_.Pos;
   end;

procedure SmartFile.SeekEof;
   begin
      Seek( FilSize_);
   end;

procedure SmartFile.ChangeBuffer;
   begin
      SwapBuffers;
      Buf1_.Pos:= 0;
      if DskPos1_<>DskPos2_+BufSize_ then begin
         if WrFlag1_ then BlockWrite;
         DskPos1_:= DskPos2_+BufSize_;
         BlockRead;
      end;
   end;

procedure SmartFile.Put;
   begin
      if Buf1_.Pos=BufSize_ then ChangeBuffer;
      if Buf1_.Ptr^<>B then WrFlag1_:= True;
      Buf1_.Ptr^:= B;
      if DskPos1_+Buf1_.Pos=FilSize_ then begin
         Inc(FilSize_);
         Inc(BufEnd1_);
      end;
   end;

function SmartFile.Get;
   begin
      if Buf1_.Pos>=BufEnd1_ then begin
         if DskPos1_+Buf1_.Pos>=FilSize_ then
            Error( 'Fatal error - read past eof');
         ChangeBuffer;
      end;
      Get:= Buf1_.Ptr^;
   end;

                               { 樮஢    }
function SmartFile.SeekAndGet;
   begin
{ ᫨    ⥪騩  }
      if (Pos<DskPos1_) or (Pos>=DskPos1_+BufEnd1_) then begin
   { ஢,   諨  ࠭ 䠩 }
         if (Pos>=FilSize_) or (Pos<0) then
            Error( 'Fatal error - read past eof');
   { ᬥ  }
         SwapBuffers;
   { ᫨     ன  }
         if (Pos<DskPos1_) or (Pos>=DskPos1_+BufEnd1_)
   {  ⮫ 㦭   ᪠ }
         then begin
            if WrFlag1_ then BlockWrite;
            DskPos1_:= Pos - (Pos mod BufSize_);
            BlockRead;
         end;
      end;
{ 樮஢ 䠩    }
      Buf1_.Pos:= Pos-DskPos1_;
      SeekAndGet:= Buf1_.Ptr^;
   end;

procedure SmartFile.WrByte;
   begin
      if Buf1_.Pos=BufSize_ then ChangeBuffer;
      Buf1_.Ptr^:= B;
      WrFlag1_:= True;
      if DskPos1_+Buf1_.Pos=FilSize_ then begin
         Inc(FilSize_);
         Inc(BufEnd1_);
      end;
      Inc( Buf1_.Pos);
   end;

procedure SmartFile.WrWord;
   begin
      Put( Lo( W));
      Inc( Buf1_.Pos);
      Put( Hi( W));
      Inc( Buf1_.Pos);
   end;

procedure SmartFile.WrLong;
   type Long= array[0..1] of Word;
   var LL: Long absolute L;

   begin
      WrWord( LL[0]);
      WrWord( LL[1]);
   end;

procedure SmartFile.WrChar;
   begin
      while Count>1 do begin
         WrByte( Byte( ' '));
         Dec( Count);
      end;
      WrByte( Byte( Ch));
   end;

procedure SmartFile.WrCharRep;
   begin
      while Count>0 do begin
         WrByte( Byte( Ch));
         Dec( Count);
      end;
   end;

procedure SmartFile.WrStr;
   var N: Byte;
       StLen: Byte absolute St;

   begin
      while Count>StLen do begin
         WrByte( Byte( ' '));
         Dec( Count);
      end;
      N:= 0;
      while N<StLen do begin
         Inc(N);
         if Buf1_.Pos=BufSize_ then ChangeBuffer;
         Buf1_.Ptr^:= Byte( St[N]);
         WrFlag1_:= True;
         if DskPos1_+Buf1_.Pos=FilSize_ then begin
            Inc(FilSize_);
            Inc(BufEnd1_);
         end;
         Inc( Buf1_.Pos);
      end;
   end;

procedure SmartFile.WrString;
   var N: Byte;
       StLen: Byte absolute St;

   begin
      WrByte( StLen);
      N:= 0;
      while N<StLen do begin
         Inc( N);
         WrByte( Byte( St[N]));
      end;
   end;

procedure SmartFile.WrLn;
   begin
      WrWord($0A0D);
   end;

procedure SmartFile.WrStrLn;
   begin
      WrStr( St, Count);
      WrLn;
   end;

procedure SmartFile.WrBuf;
   var P: BytePointer;
       N: Word;

   begin
      P.Ptr:= @Buf;
      while Count>0 do begin
         if Buf1_.Pos=BufSize_ then ChangeBuffer;
         N:= BufSize_-Buf1_.Pos;
         if N>Count then N:= Count;
         Move( P.Ptr^, Buf1_.Ptr^, N);
         Buf1_.Pos:= Buf1_.Pos+N;
         P.Pos:= P.Pos+N;
         Count:= Count-N;
         WrFlag1_:= True;
         if DskPos1_+Buf1_.Pos>FilSize_ then begin
            FilSize_:= DskPos1_+Buf1_.Pos;
            BufEnd1_:= Buf1_.Pos;
         end;
      end;
   end;

function SmartFile.RdByte;
   begin
      if Buf1_.Pos>=BufEnd1_ then begin
         if DskPos1_+Buf1_.Pos>=FilSize_ then
            Error( 'Fatal error - read past eof');
         ChangeBuffer;
      end;
      RdByte:= Buf1_.Ptr^;
      Inc( Buf1_.Pos);
   end;

function SmartFile.RdWord;
   var W: record case Byte of
            0: (Wd: Word);
            1: (Bt: array[0..1] of Byte);
          end;

   begin
      W.Bt[0]:= Get;
      Inc( Buf1_.Pos);
      W.Bt[1]:= Get;
      Inc( Buf1_.Pos);
      RdWord:= W.Wd;
   end;

function SmartFile.RdLong;
   var L: record case Byte of
            0: (Lg: LongInt);
            1: (Bt: array[0..3] of Byte);
          end;

   begin
      L.Bt[0]:= RdByte;
      L.Bt[1]:= RdByte;
      L.Bt[2]:= RdByte;
      L.Bt[3]:= RdByte;
      RdLong:= L.Lg;
   end;

function SmartFile.RdStr;
   var N: Byte;
       St: String;

   begin
      N:= 0;
      St[0]:= Chr( Count);
      while N<Count do begin
         if Buf1_.Pos>=BufEnd1_ then begin
            if DskPos1_+Buf1_.Pos>=FilSize_ then
               Error( 'Fatal error - read past eof');
            ChangeBuffer;
         end;
         Inc(N);
         St[N]:= Chr( Buf1_.Ptr^);
         Inc( Buf1_.Pos);
      end;
      RdStr:= St;
   end;

function SmartFile.RdString;
   var
      N: Byte;
      StLen: Byte;

   begin
      StLen:= RdByte;
      RdString[0]:= Chr( StLen);
      N:= 0;
      while N<StLen do begin
         Inc( N);
         RdString[N]:= Chr( RdByte);
      end;
   end;

function  SmartFile.ReadEqual;
   var
      N: Byte;
      ModelLen: Byte absolute Model;

   begin
      N:= 0;
      while N<ModelLen do begin
         if Buf1_.Pos>=BufEnd1_ then begin
            if DskPos1_+Buf1_.Pos>=FilSize_ then
               Error( 'Fatal error - read past eof');
            ChangeBuffer;
         end;
         Inc( N);
         if Buf1_.Ptr^<>Byte( Model[N]) then begin
            ReadEqual:= False;
            Exit;
         end;
         Inc( Buf1_.Pos);
      end;
      ReadEqual:= True;
   end;

procedure SmartFile.RdBuf;
   var P: BytePointer;
       N: Word;

   begin
      if DskPos1_+Buf1_.Pos+Count>FilSize_ then
               Error( 'Fatal error - read past eof');
      P.Ptr:= @Buf;
      while Count>0 do begin
         if Buf1_.Pos>=BufEnd1_ then ChangeBuffer;
         N:= BufSize_-Buf1_.Pos;
         if N>Count then N:= Count;
         Move( Buf1_.Ptr^, P.Ptr^, N);
         Buf1_.Pos:= Buf1_.Pos+N;
         P.Pos:= P.Pos+N;
         Count:= Count-N;
      end;
   end;


procedure SmartFile.Error;
   var L: Byte;

   begin
      L:= Length( Name_);
      if L< Length( Mess) then L:= Length( Mess);
      L:= Succ( L) shr 1;
      Writeln( Name_);
      Writeln( Mess);
      Halt;
   end;


procedure DBaseFile.AppendBlank;
{
 -------------------------------------------------
  Resume:  ⮩    .
  Upgrade release 22.03.95.
 -------------------------------------------------
}
   var P: Pointer;

   begin
      GetMem( P, Succ( RecSize_));
      ScatterBlank( P^);
      Byte( Ptr( Seg( P^), Ofs( P^)+RecSize_)^):= $1A;
      AppendFrom( P^);
      FreeMem( P, Succ( RecSize_));
   end;

procedure DBaseFile.FastAppend;
   var N: Word;
       P: BytePointer;

   begin
      SmartFile.Seek( RecCount_*RecSize_+HeaderSize_);
      SmartFile.WrBuf( RecSize_, Buffer);
      SmartFile.WrByte( 26);
      Inc( RecCount_);
      RecNo_:= RecCount_;
   end;


procedure DBaseFile.FastFixRecCount;
{
 -------------------------------------------------
  Resume: ४஢ ᫠ ᥩ  
  First release 22.03.95.
 -------------------------------------------------
}
   begin
      SmartFile.Seek( 4);
      SmartFile.WrLong( RecCount_);
   end;


procedure DBaseFile.FixRecCount;
{
 -------------------------------------------------
  Resume: ४஢ ᫠ ᥩ  
 -------------------------------------------------
}
   begin
      BinFile.Seek( 4);
      BinFile.BlockWrite( 4, RecCount_);
      SmartFile.UpdateBuffers( 4, 4, RecCount_);
   end;


procedure DBaseFile.AppendFrom;
   begin
      RecNo_:= Succ( RecCount_);
      BinFile.Seek( Pred( RecNo_)*RecSize_+HeaderSize_);
      BinFile.BlockWrite( Succ( RecSize_), Buffer);
      Inc( RecCount_);
      FixRecCount;
      BinFile.Flush;
      SmartFile.UpdateBuffers( Pred( RecNo_)*RecSize_+HeaderSize_,
                                          Succ( RecSize_), Buffer);
   end;

procedure DBaseFile.Append;
   begin
      AppendFrom( Buf_1^);
   end;

procedure DBaseFile.Flush;
   begin
      SmartFile.Flush;
      BinFile.Flush;
   end;

procedure DBaseFile.ScatterBlank;
   var N: Word;
       P: BytePointer;
       FP: DataPoint;
       St: String;
       StLen: Byte absolute St;

   begin
      FP:= Field_;
      P.Ptr:= @Buffer;
      P.Ptr^:= Ord(' ');      { ਧ 㤠 }
      Inc( P.Pos);
      while FP<>Nil do begin
         St:= Replicate( ' ', FP^.Size);
         if (FP^.Typ='N') then
            if FP^.DecPlaces=0 then RUpdateProc( '0', St)
            else RUpdateProc( '0.'+Replicate('0', FP^.DecPlaces), St);
         Move( St[1], P.Ptr^, StLen);
         P.Pos:= P.Pos+FP^.Size;
         FP:= FP^.Next;
      end;
   end;

{
 2.2.     .
 ----------------------------------
}
procedure DBaseFile.FastScatter;
   var P: BytePointer;
       N: Word;

   begin
      SmartFile.Seek( Pred(RecNo_)*RecSize_+HeaderSize_);
      SmartFile.RdBuf( RecSize_, Buffer);
   end;

{
 2.3.     .
 ----------------------------------
}
procedure DBaseFile.FastGather;
   begin
      SmartFile.Seek( Pred(RecNo_)*RecSize_+HeaderSize_);
      SmartFile.WrBuf( RecSize_, Buffer);
   end;

procedure DBaseFile.FastSwap;
   var P1, P2: Pointer;

   begin
      if RecNo_>=RecCount_ then Exit;
      GetMem( P1, RecSize);
      GetMem( P2, RecSize);
      FastScatter( P1^);
      Inc( RecNo_);
      FastScatter( P2^);
      FastGather( P1^);
      Dec( RecNo_);
      FastGather( P2^);
      FreeMem( P1, RecSize);
      FreeMem( P2, RecSize);
   end;

{
 2.7.  ⬥  㤠.
 -------------------------------
}
procedure DBaseFile.FastRecall;
   begin
      SmartFile.Seek( Pred(RecNo_)*RecSize_+HeaderSize_);
      SmartFile.Put( 32);
   end;

procedure DBaseFile.Recall;
   begin
      Byte( Buf_1^):= 32;
   end;

procedure DBaseFile.RecallAll;
   var N: LongInt;

   begin
      N:= 0;
      while N<RecCount_ do begin
         SmartFile.Seek( N*RecSize_+HeaderSize_);
         SmartFile.Put( 32);
         Inc( N);
      end;
   end;

function  DBaseFile.DelCount;
{
 ----------------------------------------
  Resume:  ᫠ 祭 ᥩ.
 ----------------------------------------
}
   var N, Count, Pos: LongInt;

   begin
      N:= RecCount_;
      Count:= 0;
      Pos:= HeaderSize_;
      while N>0 do begin
         if SmartFile.SeekAndGet( Pos)=Byte('*') then Inc( Count);
         Inc( Pos, RecSize_);
         Dec( N);
      end;
      DelCount:= Count;
   end;

{
 2.8. ⠭ ⬥⪨  㤠.
 -----------------------------------
}
procedure DBaseFile.FastDelete;
   begin
      SmartFile.Seek( Pred(RecNo_)*RecSize_+HeaderSize_);
      SmartFile.Put( 42);
   end;

procedure DBaseFile.Delete;
   begin
      Byte( Buf_1^):= 42;
   end;

{
 2.9. ஢ ⬥  㤠.
 -----------------------------------
}
function DBaseFile.FastDeleted;
   var B: Byte;

   begin
      SmartFile.Seek( Pred(RecNo_)*RecSize_+HeaderSize_);
      FastDeleted:= SmartFile.Get=42;
   end;

{
 2.10. ४ ⬥  㤠.
 --------------------------------------
}
procedure DBaseFile.FastToggle;
   var B: Byte;

   begin
      SmartFile.Seek( Pred( RecNo_)*RecSize_+HeaderSize_);
      B:= SmartFile.Get;
      if B=42 then B:=32
              else B:=42;
      SmartFile.Put( B);
   end;

procedure DBaseFile.Toggle;
   begin
      if Byte( Buf_1^)=42 then Byte( Buf_1^):=32
                          else Byte( Buf_1^):=42;
   end;

procedure DBaseFile.ToggleIn;
   begin
      if Byte( Buffer)=42 then Byte( Buffer):=32
                          else Byte( Buffer):=42;
   end;


{
 3. 楤 ࠡ   .
 ===================================
}

procedure DBaseFile.Open;
{
 --------------------------------
  Resume: 뢠  .
  Upgrade release 30.03.95.
 --------------------------------
}
   var P: DataPoint;
       N: Word;
       OffsetCount: Word;

   begin
      BinFile.Assign( FileName);
      SmartFile.Open( Size);
      RecNo_:= 1;
      SmartFile.Seek( 4);
      RecCount_:= SmartFile.RdLong;
      HeaderSize_:= SmartFile.RdWord;
      RecSize_:= SmartFile.RdWord;
      GetMem( Buf_1, Succ( RecSize_));
      Byte( Ptr( Seg( Buf_1^), Ofs( Buf_1^)+RecSize_)^):= $1A;
      GetMem( Buf_2, RecSize_);
      if (FilSize_ <> RecCount_*RecSize_+HeaderSize_) and
         (FilSize_ <> Succ(RecCount_*RecSize_+HeaderSize_))
            then if DBFOpenCheck then
               Error( 'ࠢ ଠ 䠩')
            else RecCount_:= (FilSize_-HeaderSize_) div RecSize_;

{  ࠪ⨪   }
      New(Field_);
      P:= Field_;
      SmartFile.Seek(32);
      OffsetCount:= 1;
      repeat
         P^.Next:= Nil;

{    }
         N:= 0;
         repeat
            Inc(N);
            P^.Name[N]:= Chr( SmartFile.RdByte);
         until N=10;
         N:= 0;
         while (P^.Name[Succ(N)]<>Chr(0)) and (N<10) do Inc(N);
         P^.Name[0]:= Chr(N);
         N:=SmartFile.RdByte;             { ய 㫥      }
         P^.Typ:= Chr( SmartFile.RdByte); {  ⨯             }
         P^.Offset:= OffsetCount;         {  ᬥ饭        }
         N:= SmartFile.RdWord;
         N:= SmartFile.RdWord;
         P^.Size:= SmartFile.RdByte;      {             }
         OffsetCount:= OffsetCount+P^.Size;
         P^.DecPlaces:= SmartFile.RdByte; {   ஡  }
         SmartFile.Seek( SmartFile.FilePos+14);
         if SmartFile.Get=13 then Exit;
         New (P^.Next);
         P:= P^.Next;
      until False;
   end;

{
 3.2.   .
 -------------------------
}
procedure DBaseFile.Close;
   var P1, P2: Datapoint;

   begin
      FreeMem( Buf_1, Succ( RecSize_));
      FreeMem( Buf_2, RecSize_);
      P1:= Field_;
      while P1<>Nil do begin
         P2:= P1^.Next;
         Dispose(P1);
         P1:= P2;
      end;
      SmartFile.Close;
   end;

procedure DBaseFile.ReOpen;
   begin
      Close;
      Open( Name_, BufSize_);
   end;


{-------------------------------------------------------}
{                              }
{-------------------------------------------------------}

procedure DBaseFile.Truncate;
{  ।: ⥪    .           }
{  : 㤠   稭  ⥪饩.      }

   begin
      if Eod then Exit;
      RecCount_:= Pred( RecNo_);
      FastFixRecCount;
      SmartFile.Seek( RecCount_*RecSize_+HeaderSize_);
      if RecCount_>0 then SmartFile.WrByte( 26);
      SmartFile.Truncate;
   end;


procedure DBaseFile.Remove;
{  ।: ⥪    .           }
{  : ⥪  㤠.                    }

   var N: LongInt;
       P: Pointer;

   begin
      if Eod then Exit;
      N:= RecNo_;
      GetMem( P, RecSize_);
      while RecNo_<RecCount_ do begin
         Inc( RecNo_);  FastScatter( P^);
         Dec( RecNo_);  FastGather( P^);
         Inc( RecNo_);
      end;
      FreeMem(P, RecSize_);
      Truncate;
      RecNo_:= N;
   end;


procedure DBaseFile.Zap;
{  :   .  }

   begin
      RecNo_:= 1;
      Truncate;
   end;


procedure DBaseFile.Pack;
{  :   祭 .   }

   var N: LongInt;
       P: Pointer;

   begin
      N:= 0;
      RecNo_:= 1;
      GetMem(P, RecSize_);
      while not Eod do begin
         if FastDeleted then Inc(N)
         else begin
            if N>0 then begin
               FastScatter( P^);  RecNo_:= RecNo_-N;
               FastGather( P^);   RecNo_:= RecNo_+N;
            end;
         end;
         Inc( RecNo_);
      end;
      FreeMem(P, RecSize_);
      if N>0 then begin
         RecNo_:= RecNo_-N;
         Truncate;
      end;
   end;


function DBaseFile.Eod;

   begin
      Eod:= (RecNo_>RecCount_) or (RecNo_<=0);
   end;


procedure DBaseFile.GoTop;
   begin
      RecNo_:= 1;
   end;

{
 3.6. ⠭ 㪠⥫  ᫥ .
 ----------------------------------------------
}
procedure DBaseFile.GoBottom;
   begin
      RecNo_:= RecCount_;
   end;

{
 3.7. ⠭ 㪠⥫   .
 --------------------------------------------
}
procedure DBaseFile.Go;
   begin
      RecNo_:= N;
   end;

{
 3.8. ९룭  ᫮ ᥩ.
 ----------------------------------------
}
procedure DBaseFile.Skip;
   begin
      RecNo_:= RecNo_+N;
   end;

{
 3.9.   ⨢ .
 ------------------------------------
}

function DBaseFile.RecNo;
   begin
      RecNo:= RecNo_;
   end;

{
 3.10.  ᫮ ᥩ   .
 -------------------------------------------
}
function DBaseFile.RecCount;
   begin
      RecCount:= RecCount_;
   end;

function DBaseFile.RecSize;
   begin
      RecSize:= RecSize_;
   end;

procedure DBaseFile.FastLocate;
   var Offs: Word;

   begin
      if RecNo_<=0 then RecNo_:= 1;
      Offs:= FieldOfs( FldName);
      while RecNo_<=RecCount_ do begin
         if ReadEqual( FldVal, Offs) then Exit;
         Inc( RecNo_);
      end;
   end;

procedure DBaseFile.FastLocateBack;
   var Offs: Word;

   begin
      if RecNo_>RecCount_ then RecNo_:= RecCount_;
      Offs:= FieldOfs( FldName);
      while RecNo_>0 do begin
         if ReadEqual( FldVal, Offs) then Exit;
         Dec( RecNo_);
      end;
   end;

procedure DBaseFile.FastLocateFirst;
   var Offs: Word;

   begin
      RecNo_:= 1;
      Offs:= FieldOfs( FldName);
      while RecNo_<=RecCount_ do begin
         if ReadEqual( FldVal, Offs) then Exit;
         Inc( RecNo_);
      end;
   end;

{
 4. 楤 ࠡ  ﬨ  .
 =========================================

 4.1.    ᯨ᪥.
 -------------------------
}

function DBaseFile.FindField;
   var DP: DataPoint;

   begin
      DP:= Field_;
      repeat
         if DP^.Name=Ident then begin
            FindField:=DP;
            Exit;
         end;
         DP:=DP^.Next;
      until DP=Nil;
      FindField:= Nil;
   end;

function DBaseFile.FieldExists;
   begin
      FieldExists:= FindField( Ident)<>Nil;
   end;

{
 4.2.     .
 ----------------------------------
}
function DBaseFile.Len;
   var  P: DataPoint;

   begin
      P:= FindField( Ident);
      if P<>Nil then Len:= P^.Size
                else Error('   '+Ident);
   end;

function DBaseFile.FieldOfs;
   var  P: DataPoint;

   begin
      P:= FindField( Ident);
      if P<>Nil then FieldOfs:= P^.Offset
                else Error('   '+Ident);
   end;

{
 4.3.   ᠬ  .
 ----------------------------------------
}
function DBaseFile.MaxLen;
   var P: DataPoint;
       L: Byte;

   begin
      P:= Field_;
      L:= 0;
      while P<>Nil do begin
         if P^.Size>L then L:= P^.Size;
         P:= P^.Next;
      end;
      MaxLen:= L;
   end;

function DBaseFile.FieldCount;
   var P: DataPoint;
       N: Byte;

   begin
      P:= Field_;
      N:= 0;
      while P<>Nil do begin
         Inc(N);
         P:= P^.Next;
      end;
      FieldCount:= N;
   end;

{
 4.4.  ᮤন .
 -----------------------------
}
procedure DBaseFile.FastReplace;
   var P: DataPoint;
       Item, N : Byte;

   begin
      if Eod then Exit;
      P:= FindField( Ident);
      if P=Nil then Error('   '+Ident);
      SmartFile.Seek( Pred(RecNo_)*RecSize_+HeaderSize_+P^.Offset);
      N:= 0;
      while N<P^.Size do begin
        Inc(N);
        if N>Length( Source) then Item:= 32
                             else Item:= Ord( Source[N]);
        SmartFile.WrByte( Item);
      end;
   end;

procedure DBaseFile.WrStr;
   begin
      SmartFile.Seek( Pred(RecNo_)*RecSize_+HeaderSize_+Offset);
      SmartFile.WrStr( Source, 0);
   end;

{
 4.5. ⥭ ᮤন .
 -----------------------------
}
function DBaseFile.FastStore;
   var P: DataPoint;
       Item, N: Byte;
       St: String;

   begin
      P:= FindField( Ident);    {     . }
      if P=Nil then Error('   '+Ident);
      if Eod then FastStore:= Replicate( ' ', P^.Size)
      else begin
         SmartFile.Seek( Pred(RecNo_)*RecSize_+HeaderSize_+P^.Offset);
         N:= 0;
         St[0]:= Chr(P^.Size);
         while N<P^.Size do begin
           Inc(N);
           St[N]:= Chr( SmartFile.RdByte);
         end;
         FastStore:= St;
      end;
   end;

function DBaseFile.RdStr;
   begin
      SmartFile.Seek( Pred( RecNo_)*RecSize_+HeaderSize_+Offset);
      RdStr:= SmartFile.RdStr( Count);
   end;

function  DBaseFile.ReadEqual;
   var
      N: Byte;
      ModelLen: Byte absolute Model;

   begin
      SmartFile.Seek( Pred( RecNo_)*RecSize_+HeaderSize_+Offs);
      N:= 0;
      while N<ModelLen do begin
         Inc( N);
         if SmartFile.RdByte<>Ord( Model[N]) then begin
            ReadEqual:= False;
            Exit;
         end;
      end;
      ReadEqual:= True;
   end;


procedure DBaseFile.ReplaceIn;
   var P: DataPoint;
       P1: BytePointer;
       N : Byte;

   begin
      P1.Ptr:= @Buffer;
      P:= FindField( Ident);
      if P=Nil then Error('   '+Ident);
      N:= 0;
      P1.Pos:= P1.Pos+P^.Offset;
      while N<P^.Size do begin
        Inc(N);
        if N>Length( Source) then P1.Ptr^:= 32
                             else P1.Ptr^:= Ord( Source[N]);
        Inc( P1.Pos);
      end;
   end;

procedure DBaseFile.Restore;
   var P: DataPoint;

   begin
      P:= FindField( Ident);
      if P=Nil then Error('   '+Ident);
      Move( Ptr( Seg( Buf_2^), Ofs( Buf_2^)+P^.Offset)^,
            Ptr( Seg( Buf_1^), Ofs( Buf_1^)+P^.Offset)^, P^.Size);
   end;

procedure DBaseFile.Replace;
   begin
      ReplaceIn( Ident, Source, Buf_1^);
   end;

function DBaseFile.StoreFrom;
   var P: DataPoint;
       P1: BytePointer;
       Item, N: Byte;
       St: String;

   begin
      P1.Ptr:= @Buffer;
      P:= FindField( Ident);
      if P=Nil then Error('   '+Ident);
      N:= 0;
      P1.Pos:= P1.Pos+P^.Offset;
      St[0]:= Chr(P^.Size);
      Move( P1.Ptr^, St[1], P^.Size);
      StoreFrom:= St;
   end;

function DBaseFile.Store;
   begin
      Store:= StoreFrom( Ident, Buf_1^);
   end;


function DBaseFile.RecordUpdated;
   begin
      RecordUpdated:= not IsEqual( Buf_1^, Buf_2^, RecSize_);
   end;

function DBaseFile.BufferUpdated;
   begin
      BufferUpdated:= not IsEqual( Buffer, Buf_2^, RecSize_);
   end;

function DBaseFile.FieldUpdated;
   var
      P: DataPoint;

   begin
      P:= FindField( Ident);
      if P=Nil then Error('   '+Ident);
      FieldUpdated:= not IsEqual
            ( Ptr( Seg( Buf_1^), Ofs( Buf_1^)+P^.Offset)^,
              Ptr( Seg( Buf_2^), Ofs( Buf_2^)+P^.Offset)^, P^.Size);
   end;

procedure DBaseFile.BackUp;
   begin
      Move( Buf_1^, Buf_2^, RecSize_);
   end;

procedure DBaseFile.BackUpBuffer;
   begin
      Move( Buffer, Buf_2^, RecSize_);
   end;

procedure DBaseFile.Undo;
   begin
      Move( Buf_2^, Buf_1^, RecSize_);
   end;

procedure DBaseFile.UndoBuffer;
   begin
      Move( Buf_2^, Buffer, RecSize_);
   end;

procedure DBaseFile.Init;
   begin
      RecNo_:= 1;
      RecCount_:= 0;
      HeaderSize_:= 33;
      RecSize_:= 1;
      Field_:= Nil;
   end;

procedure DBaseFile.AppendField;
   var
      FP, P: DataPoint;

   begin
      FP:= Field_;
      if FP=Nil then begin
         New( P);
         Field_:= P;
      end
      else begin
         while FP^.Next<>Nil do FP:= FP^.Next;
         New( P);
         FP^.Next:= P;
      end;
      HeaderSize_:= HeaderSize_+32;
      with P^ do begin
         Next:= Nil;
         Name:= Ident;
         Typ:= FTyp;
         Offset:= RecSize_;
         Size:= FSize;
         DecPlaces:= FDec;
         RecSize_:= RecSize_+Size;
      end;
   end;

procedure DBaseFile.DeleteField;
   var P1, P2: DataPoint;
       Found: Boolean;

   begin
      P1:= Field_;
      if Field_^.Name=Ident then Field_:= P1^.Next
      else begin
         Found:= False;
         repeat
            if P1^.Next=Nil then Error( '  '+Ident);
            if P1^.Next^.Name=Ident then begin
               Found:= True;
               P2:= P1;
               P1:= P1^.Next;
               P2^.Next:= P1^.Next;
            end
            else P1:= P1^.Next;
         until Found;
      end;
      P2:= P1^.Next;
      while P2<>Nil do begin
         P2^.Offset:= P2^.Offset-P1^.Offset;
         P2:= P2^.Next;
      end;
   end;

procedure DBaseFile.FastSetDate;
   var
       S: DateStr;
       X: Byte;
       NN: Integer;

   begin
      S:= CurrentDate;
      SmartFile.Seek( 1);
      Val( Copy( S, 3, 2), X, NN);
      SmartFile.WrByte( X);
      Val( Copy( S, 5, 2), X, NN);
      SmartFile.WrByte( X);
      Val( Copy( S, 7, 2), X, NN);
      SmartFile.WrByte( X);
   end;

procedure DBaseFile.Create;
   var P: DataPoint;
       N: Byte;

   begin
      BinFile.Assign( FileName);
      SmartFile.Create( Size);
      SmartFile.WrByte( 3);           { 00      : ਧ .DBF-䠩 }
      FastSetDate;                    { 01 - 03 :  ᮧ      }
      SmartFile.WrLong( 0);           { 04 - 07 : ᫮ ᥩ      }
      SmartFile.WrWord( HeaderSize_); { 08 - 09 :      }
      SmartFile.WrWord( RecSize_);    { 10 - 11 :         }
      N:= 20;
      repeat                        { 12 - 31 : १ࢨ஢    }
         SmartFile.WrByte( 0);
         Dec( N);
      until N=0;

      P:= Field_;
      while P<>Nil do begin

         N:= 0;
         while N<Length( P^.Name) do begin
            Inc(N);                     { 00 - 10 :             }
            SmartFile.WrByte( Ord( P^.Name[N]));
         end;
         N:= 11-N;
         repeat
            SmartFile.WrByte( 0);
            Dec( N);
         until N=0;
         SmartFile.WrByte( Ord( P^.Typ));    { 11      :        }
         SmartFile.WrWord( Ord( P^.Offset)); { 12 - 13 : 饭  }
         SmartFile.WrWord( 0);               { 14 - 15 : 0             }
         SmartFile.WrByte( P^.Size);         { 16      :      }
         SmartFile.WrByte( P^.DecPlaces);    { 17      : . ࠧ  }
         N:= 14;
         repeat
            SmartFile.WrByte( 0);
            Dec( N);
         until N=0;
         P:= P^.Next;
      end;
      SmartFile.WrByte( $0D);
      SmartFile.Close;
   end;

procedure DBaseFile.BubbleSort;
   type
      BubbleListPtr = ^BubbleList;
      BubbleList = record
                      Cargo: Pointer;
                      Previous,
                      Next:  BubbleListPtr;
                   end;

   var
      Sorted,                  { number of already sorted records }
      LoopCount: LongInt;      { loop counter                     }
      Start,
      LoopTime: LongInt;
      MaxBubbleSize,           { max number of records in bubble  }
      CurBubbleSize: Word;     { current number                   }
      FreePtr,
      WorkPtr,
      SavePtr,
      HeadPtr,
      TailPtr: BubbleListPtr;
      KeyOffset,
      KeySize: Word;
      P: DataPoint;
      S, S1: String;
      SaveRecNo: LongInt;
      Count: Word;

{
                 General data structures :

                    Bubble region

              Ŀ    Ŀ         Ŀ
   HeadPtr >  Cargo         Cargo              Cargo     < TailPtr
               Next      >  Next      > ....  Next     
               Previous  <  Previous  <       Previous 
                           

                   Free region

              Ŀ    Ŀ
   FreePtr >  Cargo         Cargo    
               Next      >  Next      > ....
               Previous      Previous 
                  

   Notes:
          - 'Previous' fields are underfined for head bubble
            and free region nodes;
          - 'Next' fields are undefined for tail nodes.
}
   begin
      if RecCount_<= 1 then Exit;
      P:= FindField( Ident);
      if P=Nil then Error( '  '+Ident);
      KeyOffset:= P^.Offset;
      KeySize:= P^.Size;
      LoopCount:= 0;


                                          { Check sorted part }
      Sorted:= 1;
      RecNo_:= 1;
      S1:= FastStore( Ident);
      repeat
         S:= S1;
         Inc( Sorted);
         Inc( RecNo_);
         S1:= FastStore( Ident);
      until ( S>S1) or ( Sorted=RecCount_);
      if (Sorted=RecCount_) and (S<=S1) then begin
         Exit;
      end;
      Dec( Sorted);

                                       { Define size of bubble }
      MaxBubbleSize:= BufSize_ div RecSize_;
      if MaxBubbleSize>=4 then MaxBubbleSize:= MaxBubbleSize-2;
      if MaxBubbleSize>RecCount_-Sorted
         then MaxBubbleSize:= RecCount_-Sorted;
      if MaxBubbleSize<2 then MaxBubbleSize:= 2;

                                  { Allocate memory for bubble }
      New( HeadPtr);
      GetMem( HeadPtr^.Cargo, RecSize_);
      TailPtr:= HeadPtr;
      CurBubbleSize:= MaxBubbleSize;
      while CurBubbleSize>0 do begin
         New( WorkPtr);
         GetMem( WorkPtr^.Cargo, RecSize_);
         FreePtr^.Previous:= TailPtr;
         TailPtr^.Next:= WorkPtr;
         TailPtr:= WorkPtr;
         Dec( CurBubbleSize);
      end;
      FreePtr:= HeadPtr^.Next;

      repeat
         Inc( LoopCount);

                                          { Pop bubble }
         CurBubbleSize:= 1;
         RecNo_:= RecCount_;
         FastScatter( HeadPtr^.Cargo^);
         TailPtr:= HeadPtr;
         repeat
            if RecNo_=1 then begin
               TailPtr^.Next:= FreePtr;
               FreePtr:= HeadPtr^.Next;
               WorkPtr:= HeadPtr;
               repeat
                  FastGather( WorkPtr^.Cargo^);
                  Inc( RecNo_);
                  WorkPtr:= WorkPtr^.Next;
                  Dec( CurBubbleSize);
               until CurBubbleSize=0;
            end
            else begin
               Dec( RecNo_);
               FastScatter( FreePtr^.Cargo^);
               if Compare( Ptr( Seg( FreePtr^.Cargo^),
                             Ofs( FreePtr^.Cargo^)+ KeyOffset)^,
                           Ptr( Seg( HeadPtr^.Cargo^),
                             Ofs( HeadPtr^.Cargo^)+ KeyOffset)^, KeySize)<=0
               then begin
                                   { Add record to bubble head }
                  if RecNo_>Sorted then begin
                     SavePtr:= FreePtr;
                     if CurBubbleSize<MaxBubbleSize then begin
                        FreePtr:= FreePtr^.Next;
                        Inc( CurBubbleSize);
                     end
                     else begin
                        RecNo_:= RecNo_+CurBubbleSize;
                        FastGather( TailPtr^.Cargo^);
                        RecNo_:= RecNo_-CurBubbleSize;
                        TailPtr^.Next:= FreePtr^.Next;
                        FreePtr:= TailPtr;
                        TailPtr:= TailPtr^.Previous;
                     end;
                     SavePtr^.Next:= HeadPtr;
                     HeadPtr^.Previous:= SavePtr;
                     HeadPtr:= SavePtr;
                  end
                  else begin
                     TailPtr^.Next:= FreePtr;
                     FreePtr:= HeadPtr^.Next;
                     WorkPtr:= HeadPtr;
                     repeat
                        Inc( RecNo_);
                        FastGather( WorkPtr^.Cargo^);
                        WorkPtr:= WorkPtr^.Next;
                        Dec( CurBubbleSize);
                     until CurBubbleSize=0;
                  end;
               end
               else if Compare( Ptr( Seg( TailPtr^.Cargo^),
                             Ofs( TailPtr^.Cargo^)+ KeyOffset)^,
                           Ptr( Seg( FreePtr^.Cargo^),
                             Ofs( FreePtr^.Cargo^)+ KeyOffset)^, KeySize)<0
                  then begin
                     if (CurBubbleSize<MaxBubbleSize) and (RecNo_>Sorted)
                     then begin
                                { Add record to bubble tail }
                        FreePtr^.Previous:= TailPtr;
                        TailPtr^.Next:= FreePtr;
                        TailPtr:= FreePtr;
                        FreePtr:= FreePtr^.Next;
                        Inc( CurBubbleSize);
                     end
                     else begin
                                { Move record behind bubble }
 
                        RecNo_:= RecNo_+CurBubbleSize;
                        FastGather( FreePtr^.Cargo^);
                        RecNo_:= RecNo_-CurBubbleSize;
                     end;
                  end
                  else begin
                                 { Insert record into bubble }
                  WorkPtr:= HeadPtr;
                  Count:= 0;
                  repeat
                     WorkPtr:= WorkPtr^.Next;
                     Inc( Count);
                  until Compare( Ptr( Seg( WorkPtr^.Cargo^),
                             Ofs( WorkPtr^.Cargo^)+ KeyOffset)^,
                                 Ptr( Seg( FreePtr^.Cargo^),
                             Ofs( FreePtr^.Cargo^)+ KeyOffset)^, KeySize)>=0;
                  WorkPtr:= WorkPtr^.Previous;
                  if RecNo_>Sorted then begin
                     SavePtr:= FreePtr;
                     if CurBubbleSize<MaxBubbleSize then begin
                        FreePtr:= FreePtr^.Next;
                        Inc( CurBubbleSize);
                        SavePtr^.Next:= WorkPtr^.Next;
                        SavePtr^.Previous:= WorkPtr;
                        WorkPtr^.Next:= SavePtr;
                        WorkPtr:= SavePtr^.Next;
                        WorkPtr^.Previous:= SavePtr;
                     end
                     else begin
                        RecNo_:= RecNo_+CurBubbleSize;
                        FastGather( TailPtr^.Cargo^);
                        RecNo_:= RecNo_-CurBubbleSize;
                        TailPtr^.Next:= FreePtr^.Next;
                        FreePtr:= TailPtr;
                        SavePtr^.Next:= WorkPtr^.Next;
                        SavePtr^.Previous:= WorkPtr;
                        WorkPtr^.Next:= SavePtr;
                        WorkPtr:= SavePtr^.Next;
                        WorkPtr^.Previous:= SavePtr;
                        TailPtr:= TailPtr^.Previous;
                     end;
                  end
                  else begin
                     SaveRecNo:= RecNo_;
                     RecNo_:= RecNo_+Count;
                     FastGather( FreePtr^.Cargo^);
                     TailPtr:= WorkPtr;
                     WorkPtr:= WorkPtr^.Next;
                     repeat
                        Inc( RecNo_);
                        SavePtr:= FreePtr;
                        FreePtr:= WorkPtr;
                        FastGather( WorkPtr^.Cargo^);
                        WorkPtr:= WorkPtr^.Next;
                        FreePtr^.Next:= SavePtr;
                        Dec( CurBubbleSize);
                     until Count=CurBubbleSize;
                     RecNo_:= SaveRecNo;
                  end;
               end;
            end;
         until CurBubbleSize=0;
         Sorted:= Sorted+MaxBubbleSize;
                                          { Show loop time }
      until Sorted>=RecCount;
      SmartFile.Flush;
      HeadPtr^.Next:= FreePtr;
      Inc( MaxBubbleSize);
      repeat
         SavePtr:= HeadPtr;
         HeadPtr:= HeadPtr^.Next;
         FreeMem( SavePtr^.Cargo, RecSize_);
         Dispose( SavePtr);
         Dec( MaxBubbleSize);
      until MaxBubbleSize=0;
   end;

procedure DBaseFile.Gather;       {    }
   begin
      if Eod then Exit;
      BinFile.Seek( Pred( RecNo_)*RecSize_+HeaderSize_);
      BinFile.BlockWrite( RecSize_, Buf_1^);
      BinFile.Flush;
      SmartFile.UpdateBuffers( Pred( RecNo_)*RecSize_+HeaderSize_,
                                                 RecSize_, Buf_1^);
   end;

procedure DBaseFile.GatherFrom;       {    }
   begin
      if Eod then Exit;
      BinFile.Seek( Pred( RecNo_)*RecSize_+HeaderSize_);
      BinFile.BlockWrite( RecSize_, Buffer);
      BinFile.Flush;
      SmartFile.UpdateBuffers( Pred( RecNo_)*RecSize_+HeaderSize_,
                                                 RecSize_, Buffer);
   end;

procedure DBaseFile.Scatter;      { ⥭  ᪠ }
   begin
      if Eod then ScatterBlank( Buf_1^)
      else begin
         BinFile.Seek( Pred( RecNo_)*RecSize_+HeaderSize_);
         BinFile.BlockRead( RecSize_, Buf_1^);
         SmartFile.UpdateBuffers( Pred( RecNo_)*RecSize_+HeaderSize_,
                                                    RecSize_, Buf_1^);
      end;
   end;


end.
