uses MIDIDrv, Crt, Dos;

Const
  Ramka_1 = '';
  Ramka_2 = '';

Type
  SetUp_rec  = record
               MType   : word;
               MPort   : word;
               MDevice : word;
               end;
  Cat        = array[1..500] of SearchRec;

var
  MIDI_File: file;
  SetUpFile: file of setup_rec;
  MIDI_Size: word;
  SetUpSize: word;
  MIDI_Data: pointer;
  SetUp    : SetUp_rec;
  DirInfo  : SearchRec;
  Catalog  : Cat;
  Num      : Word;

Procedure SetUpLoad;
Begin
  Assign(SetUpFile,'SETUP.DAT');
  {$i-}
  Reset(SetUpFile);
  {$i+}
  Read(SetUpFile,SetUp);
  Close(SetUpFile);
End;

Procedure Load_Scr;
Begin
  TextBackGround(Blue);
  GoToXY(1,10);
  Writeln('',Ramka_2,Ramka_2,'Ŀ');
  Writeln('                                            ');
  Writeln('',Ramka_2,Ramka_2,'');
  TextBackGround(Red);
  GoToXY(6,10);
  Writeln('Files');
  TextBackGround(Blue);
  GoToXY(3,11);
  Write(Catalog[1].Name);
  TextBackGround(Black);
End;

Procedure Load;
Var
  C1      : Word;
Begin
  GoToXY(1,10);
  C1:=0;
  FindFirst('*.MID', Archive, DirInfo);
  While DosError = 0 do
  begin
    IF DirInfo.size < 65535 then
       Begin
         C1:=C1+1;
         Catalog[C1] := Dirinfo;
       End;
    FindNext(DirInfo);
  end;
  C1:=C1+1;
  Catalog[C1].Name := 'END';
End;


Procedure Screen;
Var
  MDevice : String[11];
  MPort  : Word;

Begin
  TextBackGround(Black);
  TextBackGround(Blue);
  TextColor(White);
  Case SetUp.MDevice of
       0 : MDevice:= 'IN     ';
       1 : MDevice:= 'OUT    ';
       2 : MDevice:= 'MNP 401';
       end;

  Case SetUp.MPort of
       528 : MPort:= 210;
       544 : MPort:= 220;
       560 : MPort:= 230;
       576 : MPort:= 240;
       592 : MPort:= 250;
       608 : MPort:= 260;
       904 : MPort:= 388;
       end;

  GoToXY(1,4);
  Writeln('',Ramka_1,'');
  GoToXY(1,5);
  Writeln(' MIDI Port   :',MPort,'               -1 to change ');
  GoToXY(1,6);
  Writeln(' MIDI Type   :',SetUp.MType,'                 -2 to change ');
  GoToXY(1,7);
  Writeln(' MIDI Device :',MDevice,'           -3 to change ');
  GoToXY(1,8);Writeln('',Ramka_1,'');

  TextBackGround(Blue);
  GoToXY(2,19);  Writeln('ͻ');
  GoToXY(2,20);  Writeln('                  ');
  GoToXY(2,21);  Writeln('                  ');
  GoToXY(2,22);  Writeln('                  ');
  GoToXY(2,23);  Writeln('ͼ');
  TextColor(Green);
  GoToXY(4,21);  Writeln('');
  TextColor(Red);
  GoToXY(10,21);  Writeln(#16);
  TextColor(White);
  TextBackGround(red);
  GoToXY(20,4);  Writeln('SET UP');
  GoToXY(9,19); Writeln('Player');
  GoToXY(1,1);
  Writeln('    DOS  MIDI  Player  v1.0         by Arkhipov Egor      version FREEWARE      ');
  TextBackGround(Black);
  TextBackGround(7);
  GoToXY(50,18);  Writeln('Ŀ');
  GoToXY(50,19);  Writeln('o                          o');
  GoToXY(50,20);  Writeln('o  Special thanks to :     o');
  GoToXY(50,21);  Writeln('o  Kovalev A.V. (Midi.obj) o');
  GoToXY(50,22);  Writeln('o  Borland Inc. (Pascal)   o');
  GoToXY(50,23);  Writeln('o                          o');
  GoToXY(50,24);  Writeln('');
  TextBackGround(Black);
End;

Procedure SetMIDI_Port;
Var C1 : Byte;
    R  : Char;
Begin
  TextBackGround(Blue);
  GoToXY(50,4);  Writeln('ͻ');
  TextBackGround(Red);
  GoToXY(54,4);  Writeln('PORT');
  TextBackGround(Blue);
  GoToXY(50,5);  Writeln(' 1 - 210   ');
  GoToXY(50,6);  Writeln(' 2 - 220   ');
  GoToXY(50,7);  Writeln(' 3 - 230   ');
  GoToXY(50,8);  Writeln(' 4 - 240   ');
  GoToXY(50,9);  Writeln(' 5 - 250   ');
  GoToXY(50,10);  Writeln(' 6 - 260   ');
  GoToXY(50,11);  Writeln(' 7 - 388   ');
  GoToXY(50,12); Writeln('ͼ');
  R:=' ';
  While (R >'7')or(R<'1') do
    Begin
    R:=ReadKey;
    Case R of
         '1' : SetUp.MPort := $210;
         '2' : SetUp.MPort := $220;
         '3' : SetUp.MPort := $230;
         '4' : SetUp.MPort := $240;
         '5' : SetUp.MPort := $250;
         '6' : SetUp.MPort := $260;
         '7' : SetUp.MPort := $388;
         #27 : Break;
         end;
    End;
  TextBackGround(Black);
  For C1 := 4 to 12 do
  Begin
    GoToXY(50,C1);
    Writeln('             ');
  End;
  TextBackGround(Blue);
  Screen;
End;

Procedure SetMIDI_Type;
Var C1 : Byte;
    R  : Char;
    P  : Word;
    P2 : Integer;
Begin
  TextBackGround(Blue);
  GoToXY(50,4);  Writeln('ͻ');
  GoToXY(50,5);  Writeln('             ');
  GoToXY(50,6);  Writeln('ͼ');
  TextBackGround(Red);
  GoToXY(51,4);  Writeln('Set MIDI type');
  TextBackGround(Blue);
  R:=' ';
  GoToXY(52,5);
  While (R<'0')or(R>'9') do
  Begin
    If KeyPressed then
       Begin
         R:=Readkey;
         Case R of
              #27      : Break;
              '0'..'9' : Begin
                           Write(R);
                           Val(R,P,p2);
                           SetUp.Mtype:=P;
                           Screen;
                           Delay(100);
                         End;
              end;
       End;
   End;
  TextBackGround(Black);
  For C1 := 4 to 6 do
  Begin
    GoToXY(50,C1);
    Writeln('                ');
  End;
  TextBackGround(Blue);
End;

Procedure SetMIDI_Dev;
Var C1 : Byte;
    R  : Char;
Begin
  TextBackGround(Blue);
  GoToXY(50,4);  Writeln('ͻ');
  TextBackGround(Red);
  GoToXY(55,4);  Writeln('Device');
  TextBackGround(Blue);
  GoToXY(50,5);  Writeln(' 1 - IN      ');
  GoToXY(50,6);  Writeln(' 2 - OUT     ');
  GoToXY(50,7);  Writeln(' 3 - MPU-401 ');
  GoToXY(50,8);  Writeln('ͼ');
  R:=' ';
  While (R >'3')or(R<'1') do
    Begin
    R:=ReadKey;
    Case R of
         '1' : SetUp.MDevice := 0;
         '2' : SetUp.MDevice := 1;
         '3' : SetUp.MDevice := 2;
         #27 : Break;
         end;
    End;
  TextBackGround(Black);
  For C1 := 4 to 8 do
  Begin
    GoToXY(50,C1);
    Writeln('                 ');
  End;
  TextBackGround(Blue);
  Screen;
End;

Procedure Down;
Begin
  If Catalog[num+1].Name <> 'END' Then Num:=Num+1;
  GoToXY(3,11);
  TextBackGround(Blue);
  Write('                   ');
  GoToXY(3,11);
  Write(Catalog[num].Name);
  TextBackGround(Black);
End;


Procedure Up;
Begin
  If Num>1 then Num:=Num-1;
  GoToXY(3,11);
  TextBackGround(Blue);
  Write('                   ');
  GoToXY(3,11);
  Write(Catalog[num].Name);
  TextBackGround(Black);
End;

Procedure Play;
Begin
  TextBackGround(Blue);
  TextColor(Red);
  GoToXY(4,21);  Writeln('');
  TextColor(Green);
  GoToXY(10,21);  Writeln(#16);
  TextColor(White);

  MIDISetPort( SetUp.MPort , SetUp.MDevice);
  MIDIInit( SetUp.MType );
  Assign( MIDI_File, Catalog[num].name);
  Reset( MIDI_File, 1);
  MIDI_Size := FileSize( MIDI_File );
  GetMem( MIDI_Data, MIDI_Size);
  blockread( MIDI_File, MIDI_Data^, MIDI_Size );
  close( MIDI_File );
  While true do
    Begin
      if MIDIStatus = 0 then MIDIPlay( MIDI_Data );
      If KeyPressed then
         Case Readkey of
              #27 : Break;
              end;
    End;

  MIDIUnInit;
  FreeMem( MIDI_Data, MIDI_Size);
  TextColor(green);
  GoToXY(4,21);  Writeln('');
  TextColor(Red);
  GoToXY(10,21);  Writeln(#16);
  TextColor(White);
  TextBackGround(Black);
End;

Procedure Key;
Begin
  While true do
  Begin
    Case Readkey of
         '1'   :  SetMIDI_Port;
         '2'   :  SetMIDI_Type;
         '3'   :  SetMIDI_Dev;
          #72  : Up;
          #80  : Down;
          #13  : Begin
                   Play;
                 End;
          #27  : Break;
     end;
  End;
End;

Procedure MIDISetup;
Begin
End;

Begin
  TextBackGround(black);
  Num:=1;
  ClrScr;
  SetUpLoad;
  Screen;
  Load;
  Load_Scr;
  Key;

  Assign(SetUpFile,'SETUP.DAT');
  {$i-}
  Reset(SetUpFile);
  {$i+}
  Write(SetUpFile,SetUp);
  Close(SetUpFile);
  ClrScr;
  Writeln('Arkhipov Egor. All Right Reserved. 1996');
  Writeln('Wait for new version');
End.