(*
**
** SYSTEM.INC, System information support file
**
** Copyright (c) 1996 by Maarten Bekers
**
** Created : 16-Apr-1996
** Last update : 29-Apr-1996
**
**
*)

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)

Function GetBIOSDate: String;
Var Str: String;
    Add: Word;
Begin;
 Str := '';
 Add := $FFF5;
 While (Char(Mem[$F000:$0000+Add]) in [#32..#255]) AND (Length(Str)<100) do
  Begin;
   Str := Str + Char(Mem[$F000:$0000+Add]);
   Inc(Add, $0001);
  End; { While Mem }
 GetBiosDate := Str;
End; { func. BiosDate }

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)

Procedure GetComputerName(Var ComputerName, ComputerRevision: String);
Var Temp          : String;
    Teller1       : Word;
    DellMachine   : Boolean;
    MachineIDByte : Byte;
    MachineIDWord : Word;
    RomDate       : String;
Begin;
 RomDate := GetBiosDate;

 ComputerName := '';
 If UpCase(Chr(Mem[$F000:$E076])) = 'D' then
  Begin;                                             { DELL computer detected }
   Temp := '';
   For Teller1 := $E077 to $E079 do
    Temp := Temp + Upcase(Chr(Mem[$F000:Teller1]));
   If Temp='ELL' then
    Begin;
     ComputerName := 'Dell';
     DellMachine  := True;
     MachineIDByte:= Mem[$F000:$E845];
     If MachineIDByte in DellNums then
      Temp := Temp + ' ' + Dells[MachineIDByte];
    End { Not "Temp='ELL'" }
     else Begin;
            Temp := Temp + ' ' + 'unkown - ID is ' + HexByte(MachineIDByte);
            DellMachine := False;
          End; { Else Begin }
  End; { if UpCase = 'D' }

 Regs.AX    := $6F00;
 Regs.BX    := $00;
 Regs.Flags := Regs.Flags AND FCarry;
 Intr($16, Regs);
 If NoCarry(Regs) AND (Regs.BX=$4850) then
  Begin;
   ComputerName := ComputerName + 'HP Vectra Series (BIOS Call says)';
  End; { if NoCarrie }

 Regs.AH    := $C0;
 Regs.ES    := 00;
 Regs.BX    := 00;
 Regs.Flags := Regs.Flags AND FCarry;
 Intr($15, Regs);
 If NoCarry(Regs) AND (Regs.AH=00) then
  Begin;
   RomInfoSeg    := Regs.ES;
   RomInfoOfs    := Regs.BX;
   MachineIDWord := MemW[Regs.ES:Regs.BX + 02];
   MachineIDByte := Mem[Regs.ES:Regs.BX + 04];
   Case MachineIDWord of
     $00FC : If MachineIDByte=01 then
                ComputerName := ComputerName + ' ' + 'PC-AT 2x9, 6Mhz'
                 else ComputerName := ComputerName + ' ' + 'Indsutrial AT 7531/2';
     $01FC : Case MachineIdByte of
                 $00: Begin;
                       If RomDate = '11/15/85' then
                        ComputerName := ComputerName + ' ' + 'PC-AT 319 or 339, 8Mhz'
                         else
                          If RomDate = '01/15&88' then
                           ComputerName := ComputerName + ' ' + 'Toshiba T5200/100'
                            else
                             If RomDate = '12/26*89' then
                              ComputerName := ComputerName + ' ' + 'Toshiba T1200/XE'
                               else
                                If RomDate = '07/24&90' then
                                 ComputerName := ComputerName + ' ' + 'Toshiba T5200/200'
                                  else
                                   If RomDate = '09/17/87' then
                                    ComputerName := ComputerName + ' ' + 'Tandy 3000'
                                     else ComputerName := ComputerName + ' ' +
'AT Clone';
                      End; { $00 }
                 $30: ComputerName := ComputerName + ' ' + 'Tandy 3000NL'
                  else ComputerName := ComputerName + ' ' + 'Compaq 286/386 or clone';
              End; { Case }

     $02FC  : ComputerName := ComputerName + ' ' + 'PC-XT/286';
     $04FC  : If MachineIdByte = 03 then
               ComputerName := ComputerName + ' ' + 'PS/2 Model 50Z 10Mhz 286'
                else
                 ComputerName := ComputerName + ' ' + 'PS/2 Model 50 10Mhz 286';
     $05FC  : ComputerName := ComputerName + ' ' + 'PS/2 Model 60 10MHz 286';
     $06FC  : ComputerName := ComputerName + ' ' + '7552 Gearbox';
     $09FC  : If MachineIdByte=02 then
                 ComputerName := ComputerName + ' ' + 'PS/2 Model 30-286'
                  else
                   ComputerName := ComputerName + ' ' + 'PS/2 Model 25-286';
     $0BFC  : ComputerName := ComputerName + ' ' + 'PS/1 Model 2011 10MHz 286';
     $42FC  : ComputerName := ComputerName + ' ' + 'Olivetti M280';
     $45FC  : ComputerName := ComputerName + ' ' + 'Olivetti M380 (XP1, 3, or 5)';
     $48FC  : ComputerName := ComputerName + ' ' + 'Olivetti M290';
     $4FFC  : ComputerName := ComputerName + ' ' + 'Olivetti M250';
     $50FC  : ComputerName := ComputerName + ' ' + 'Olivetti M380 (XP7)';
     $51FC  : ComputerName := ComputerName + ' ' + 'Olivetti PCS286';
     $52FC  : ComputerName := ComputerName + ' ' + 'Olivetti M300';
     $81FC  : ComputerName := ComputerName + ' ' + 'AT clone with Phoenix 386 BIOS';
     $00FB  : If MachineIDByte=01 then
               ComputerName := ComputerName + ' ' + 'PC-XT with Enhanced KBD, 3.5" support'
                else
                 ComputerName := ComputerName + ' ' + 'PC-XT';
     $01FB  : ComputerName := ComputerName + ' ' + 'PC-XT/2';
     $4CFB  : ComputerName := ComputerName + ' ' + 'Olivetti M200';
     $00FA  : ComputerName := ComputerName + ' ' + 'PS/2 Model 30';
     $01FA  : ComputerName := ComputerName + ' ' + 'PS/2 Model 25/25L';
     $4EFA  : ComputerName := ComputerName + ' ' + 'Olivetti M111';
     $00F9  : ComputerName := ComputerName + ' ' + 'PC-Convertible';
     $00F8  : ComputerName := ComputerName + ' ' + 'PS/2 Model 80 16MHz 386';
     $01F8  : ComputerName := ComputerName + ' ' + 'PS/2 Model 80 20MHz 386';
     $04F8  : ComputerName := ComputerName + ' ' + 'PS/2 Model 70 20MHz 386';
     $09F8  : ComputerName := ComputerName + ' ' + 'PS/2 Model 70 16MHz 386';
     $0BF8  : ComputerName := ComputerName + ' ' + 'PS/2 Model P70';
     $0CF8  : ComputerName := ComputerName + ' ' + 'PS/2 Model 55SX 16MHz 386SX';
     $0DF8  : ComputerName := ComputerName + ' ' + 'PS/2 Model 70 25MHz 386';
     $11F8  : ComputerName := ComputerName + ' ' + 'PS/2 Model 90 25MHz 386';
     $13F8  : ComputerName := ComputerName + ' ' + 'PS/2 Model 90 33MHz 386';
     $14F8  : ComputerName := ComputerName + ' ' + 'PS/2 Model 90-AK9 25MHz 486';
     $16F8  : ComputerName := ComputerName + ' ' + 'PS/2 Model 90-AKD 33MHz 486';
     $19F8  : ComputerName := ComputerName + ' ' + 'PS/2 Model 35/35LS/40 20MHz 386SX';
     $1BF8  : ComputerName := ComputerName + ' ' + 'PS/2 Model 70 25MHz 486';
     $1CF8  : ComputerName := ComputerName + ' ' + 'PS/2 Model 65-121 16MHz 386SX';
     $1EF8  : ComputerName := ComputerName + ' ' + 'PS/2 Model 55LS 16MHz 386SX';
     $23F8  : ComputerName := ComputerName + ' ' + 'PS/2 Model L40 20MHz 386SX';
     $25F8  : ComputerName := ComputerName + ' ' + 'PS/2 Model M57 20MHz 386SLC';
     $26F8  : ComputerName := ComputerName + ' ' + 'PS/2 Model 57 20MHz 386SX';
     $2AF8  : ComputerName := ComputerName + ' ' + 'PS/2 Model 95 50MHz 486';
     $2BF8  : ComputerName := ComputerName + ' ' + 'PS/2 Model 90 50MHz 486';
     $2CF8  : ComputerName := ComputerName + ' ' + 'PS/2 Model 95 20MHz 486SX';
     $2DF8  : ComputerName := ComputerName + ' ' + 'PS/2 Model 90 20MHz 486SX';
     $2EF8  : ComputerName := ComputerName + ' ' + 'PS/2 Model 95 20MHz 486SX+487SX';
     $2FF8  : ComputerName := ComputerName + ' ' + 'PS/2 Model 90 20MHz 486SX+487SX';
     $30F8  : ComputerName := ComputerName + ' ' + 'PS/1 Model 2121 16MHz 386SX';
     $50F8  : ComputerName := ComputerName + ' ' + 'PS/2 Model P70 16MHz 386';
     $52F8  : ComputerName := ComputerName + ' ' + 'PS/2 Model P75 33MHz 486';
     $61F8  : ComputerName := ComputerName + ' ' + 'Olivetti P500';
     $62F8  : ComputerName := ComputerName + ' ' + 'Olivetti P800';
     $80F8  : ComputerName := ComputerName + ' ' + 'PS/2 Model 80 25 MHz 386';
      else
       ComputerName := ComputerName + ' ' + 'unknown machine - model/type word: '+HexWord(MachineIDWord);
   End; { Case }
   ComputerRevision := FStr(Mem[RomInfoSEG: RomInfoOFS + 04]);
  End { If NoCarry }
   else
    If Mem[$F000:$C000] = $21 then
     ComputerName := ComputerName + ' ' + 'Tandy 1000'
      else Begin;
            MachineIDByte := Mem[$FFFF: $000E];
            Case MachineIdByte of
              $FF : Begin;
                     If Mem[$F000:$FFFD] = $46 then
                      ComputerName := ComputerName + ' ' + 'Olivetti M15'
                       else Begin;
                             ComputerName := ComputerName + ' ' + 'PC';
                             If RomDate = '04/24/81' then
                              ComputerName := ComputerName + ' ' + '(original)'
                               else If RomDate='10/19/81' then
                                ComputerName := ComputerName + ' ' + '(revised BIOS)'
                                 else If RomDate='10/27/82' then
                                  ComputerName := ComputerName + ' ' + '(HD, 640K, EGA Supported)'
                                   else ComputerName := ComputerName + ' ' + '(clone)';
                            End; { else begin }
                    End; { $FF }
              $FE : Begin;
                     If Mem[$F000:$FFFD] = $43 then
                      ComputerName := ComputerName + ' ' + 'Olivette M240'
                       else Begin;
                             ComputerName := ComputerName + ' ' + 'PC-XT';
                             If RomDate = '11/08/82' then
                              ComputerName := ComputerName + ' ' + 'or portable'
                               else If RomDate<>'08/16/82' then
                                ComputerName := ComputerName + ' ' + 'clone';
                            End; { Else }
                    End; { $FE }
              $FD : ComputerName := ComputerName + ' ' + 'PCjr';
              $FC : ComputerName := ComputerName + ' ' + 'PC-AT';
              $9A : ComputerName := ComputerName + ' ' + 'Compaq XT or Compaq Plus';
              $30 : ComputerName := ComputerName + ' ' + 'Sperry PC';
              $2D : ComputerName := ComputerName + ' ' + 'Compaq PC or Compaq Deskpro';
               else
                 ComputerName := ComputerName + ' ' + 'unknown machine - model/type byte: '+HexWord(MachineIDByte);
            End; { Case }
           End;
 ComputerName := Trim(ComputerName);
End; { proc. GetComputerName }

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)

Function GetEBiosData: String;
Begin;
 If ReadBit(Mem[RomInfoOFS: RomInfoSEG + 05], 02) then
  Begin;
   Regs.AH := $C1;
   Intr($15, Regs);
   If NoCarry(Regs) then
    GetEBiosData := HexWord(Regs.ES)
     else GetEBiosData := 'Unknown.';
  End
   else GetEBiosData := '(none)';
End; { GetEBIosData }

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)

Function BiosScan(A, B, C: Word; Var OfsFound: Word): Boolean;

Function Scan(ScanStr: String; StartSeg,StartOfs,StartRange:Word; Var OfsFound2:
Word): Boolean;
Var Counter     : LongInt;
    Scanner     : Byte;
    Len         : Byte;
    Finished1   : Boolean;
    Finished2   : Boolean;
Begin;
 Counter := StartOfs;
 Len := Length(ScanStr);
 Finished1 := False;
 Repeat;
  If Counter <= LongInt(StartRange) - Len + 01 then
   Begin;
    Scanner := 00;
    Finished2 := False;
    Repeat;
     If Scanner < Len then
      If UpCase(Chr(Mem[StartSeg : Counter + Scanner])) = ScanStr[Scanner + 01] 
then
       Inc(Scanner)
        else Begin;
              Finished2 := True;
              Inc(Counter);
             End
              Else Begin;
                    Finished2:=true;
                    Finished1:=true;
                    OfsFound2 := Counter;
                    Scan := True;
                   End;
    Until Finished2;
   End { If Counter }
    else Begin;
          Finished1 := True;
          Scan := False;
         End;
 Until Finished1;
End; { func. Scan }

Const Max     = 03;
      Notice  : Array[1..Max] of String = ('(C)', 'COPR.', 'COPYRIGHT');
    var
      i : 1..max;
      len : byte;
      target : string;
      xbool : boolean;
      xlong : longint;
      xword : word;

Begin;
 XLong := C;
 XBool := False;
 For I := 01 to Max do
  Begin;
   Target := Notice[I];
   Len := Length(Target);
   If XBool then XLong := LongInt(XWord) - 2 + len;
   If (XLong >= B) AND (XLong <= C) and (Scan(Target, a, b, xlong, xword))
    then XBool := True;

   If XBool then
    Begin;
      While (XWord > B) AND (Chr(MEM[A : XWord - 1]) in [#32..#255]) do
        Dec(xword);
      OfsFound:=xword
    End;
  End; { For }
 BIOSscan:=xbool
End; { func. BiosScan }

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)

Function ShowBios(Seg, Ofs:Word): String;
Var Temp     : String;
    Finished : Boolean;
    TempCH   : Char;
    Counter  : Word;
Begin;
 Temp := '';
 Finished := False;
 Counter := 00;
 Repeat;
  TempCH := Chr(MEM[Seg: Ofs]);

  If (TempCH in [#32..#126]) AND (NOT (TempCH in ['$'])) then
    Temp := Temp + TempCH;

  If Ofs<$FFFF then Inc(Ofs)
     else Finished := True;
  If TempCH in [#00,'$'] then Finished := True;

  Inc(Counter);

 Until (Finished) OR (Counter>65500);
 ShowBios := Temp;
End; { func. ShowBios }

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)

Function GetBIOSName: String;
Var ScanOfs: Word;
    TempStr: String;
    Temp2  : String;
    Teller : Byte;
Begin;
 Temp2 := '';
 If BiosScan(PCRomSeg, $C000, $FFFF, ScanOfs) then
  TempStr := ShowBios(PCRomSeg, ScanOfs)
   else TempStr := '(unknown)';

 For Teller:=1 to SupportedBiosses
  do If Pos(SUpcase(BiosNames[Teller]), SUpcase(TempStr))>0 then
   If Temp2='' then Temp2 := BiosNames[Teller]
    else Temp2 := Temp2 + '/' + BiosNames[Teller];

 If Temp2='' then Temp2 := BiosNames[1];
 GetBiosName := Temp2;

End; { func. GetBiosName }

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)

Function ShowBiosExtensions: String;
Var ScanSeg : Word;
    ScanOfs : Word;
    Scanner : Word;
    SegFound: Boolean;
Begin;
 ShowBiosExtensions := '';
 WriteLn;
 WriteLn('  Segment Size  Copyright notice');
 Writeln('  ------- ----  -----------------------------------------------------');
 ScanSeg := BIOSCSeg;
 SegFound:= False;
 For Scanner:=00 to 94 do
  Begin;
   If (MemW[ScanSeg : 00] = BIOSExt) then
    Begin;
     Write('  ', HexWord(ScanSeg), '    ', ((LongInt(512) * Mem[ScanSeg: 2] div 
1024)):3,'k  ');
     if BIOSscan(ScanSeg, $0000, $4FFF, ScanOfs) then
       Writeln(Trim(ShowBios(ScanSeg, ScanOfs))) else
        Writeln('(none)');
    End; { If Extension found }
    Inc(ScanSeg, $0080);
  End; { For Scanner }
End; { func. ShowBiosExtensions }

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)

Function ShowPCIBus: String;
Begin;
 ShowPCIBus := '';
 Regs.AX := $B101;
 Intr($1A, Regs);
 If Regs.AH=$00 then
   ShowPCIBus := 'PCI installed'
    else ShowPCIBus := '(not installed)';
End; { func. ShowPCIBus }

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)

Function ShowPCMCIA: String;
Begin;
 ShowPCMCIA := '';
 Regs.AH := $80;
 Intr($1A, Regs);
 If NoCarry(Regs) then
   ShowPCMCIA := 'PCMCIA installed ('+FStr(Regs.AL)+' adapters present)'
    else ShowPCMCIA := '(not installed)';
End; { func. ShowPCMCIA }

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)


Procedure ShowSystemInfo;
Var ComputerName    : String;
    ComputerRevision: String;
    ComputerAttrib  : Byte;
Begin;
 GetComputerName(ComputerName, ComputerRevision);
 ComputerAttrib := Mem[RomInfoSeg : RomInfoOfs + 05];
 Writeln('Computer Name                        : ',ComputerName);
 Writeln(' DMA Channel 3 used                  : ',Bit2Str(ComputerAttrib, 07));
 Writeln(' Slave 8259 Present                  : ',Bit2Str(ComputerAttrib, 06));
 Writeln(' Real-Time Clock                     : ',Bit2Str(ComputerAttrib, 05));
 Writeln(' Keyboard Intercept Available        : ',Bit2Str(ComputerAttrib, 04));
 Writeln(' Wait for external event             : ',Bit2Str(ComputerAttrib, 03));
 Writeln(' Extended BIOS data area Segment     : ',GetEBiosData);
 Writeln(' MCA BUS instead of ISA BUS          : ',Bit2Str(ComputerAttrib, 01));
 Writeln(' MCA BUS AND ISA BUS                 : ',Bit2Str(ComputerAttrib, 00));
 Writeln(' Keyboard Get functionallity support : ',Bit2Str(Mem[RomInfoSeg :
RomInfoOfs + 06], 06));
 Writeln(' PCI BUS                             : ',ShowPCIBus);
 Writeln(' PCMCIA                              : ',ShowPCMCIA);
 Writeln('BIOS Name                            : ',GetBiosName);
 Writeln('BIOS Date                            : ',GetBiosDate);
 Writeln('BIOS Revision level                  : ',ComputerRevision);
 Writeln('BIOS Extensions                      : ',ShowBiosExtensions);
End; { proc. ShowSystemInfo }
